'       o  2=Rx          Jumper:                          Betrieb  Prog.   Debug
'       o  3=Tx          3-4  CC liest von GPS               X               X
'                        6-7  CC schreibt in GPS             X
'       o  5 = Gnd       2-3  Computer programmiert CC               X
'                        5-6  Computer liest von CC                  X       X
'       o o o o o o o    1-2  Computer schreibt in GPS
'       1 2 3 4 5 6 7    4-5  Computer liest von GPS

define test 0             ' einfacher Debug-Code an serielle Schnittstelle
define testb 0            ' alle Bits an serielle Schnittstelle

define LCDP byteport[1]   ' Daten fr LCD

define Pow  port[09]      ' GPS-Modul Power
define DO   port[10]      ' DCD Out
define KeyP port[11]      ' Taste
define LEDr port[12]      ' LEDr
define LEDg port[13]      ' LEDg
define LEDb port[14]      ' LEDb
define LCDE port[15]      ' /Enable
define LCDD port[16]      ' Befehl=0, Data=1

define Hell da[1]         ' LED-Helligkeit

define Ngps word[1]       ' Koordinaten Nord vom GPS      in GGmm'
define Ogps word[2]       ' Koordinaten Ost  vom GPS
define Ntab word[3]       ' Koordinaten Nord von Tabelle
define Otab word[4]       ' Koordinaten Ost  von Tabelle
define Sat  byte[09]      ' Anzahl Satelliten
define NSf  byte[10]      ' Nord-Sd-Flag
define WEf  byte[11]      ' West-Ost-Flag
define aa   byte[12]      ' allgemeines Byte
define ab   byte[13]      ' allgemeines Byte
define zi   byte[14]      ' Ziffer zum Senden als DCF-77
define loc  byte[15]      ' Zeitzonen-Kennziffer
define ZZ   byte[16]      ' Zeitzone (Stunden) + 100
define ZM   byte[17]      ' Zeitzone (Minuten)
define Pho  byte[18]      ' vorlufige Stunde
define Pmi  byte[19]      ' vorlufige Minute
define Pse  byte[20]      ' vorlufige Sekunde

define SatF bit[186]      ' Flag fr "bereits Satelliten gefunden"
define Key  bit[187]      ' Zustand der Taste   on=offen, off=gedrckt
define Par  bit[188]      ' Parity-Speicher
define DCO  bit[189]      ' DCF-77 --> 0 oder 1
define SoWi bit[190]      ' Flag: off=Normalzeit,  on=Sommerzeit
define ManU bit[191]      ' Flag: off=automatisch, on=manuelle Uhrzeit
define ManZ bit[192]      ' Flag: off=automatisch, on=manuelle Zeitzone


HOUR   = 0
MINUTE = 0
SECOND = 0
DAY    = 1
MONTH  = 1
YEAR   = 1
DOW    = 1

LCDE = 1        ' LCD Enable-Takt
LEDr = 1        ' aus
LEDg = 1        ' aus
LEDb = 1        ' aus
Pow  = 0        ' ein
SatF = 0
Sat  = 0
ZZ   = 0
ZM   = 0
ManU = 0
ManZ = 0
Hell = 7

#Init
aa = &B00110000           ' Init: 8 bit
gosub LCBefehl
aa = &B00001100           ' Init: LCD ein, Scrollen aus, Cursor aus
gosub LCBefehl
aa = &B00000001           ' Init: LCD clear
gosub LCBefehl
ab = 144                  ' "Initialisierung"
gosub Message
aa = &B01000000           ' CG-Adresse 0
gosub LCBefehl
aa = &B00000001
gosub LCData              ' schmale "1" ganz rechts
aa = &B00000011
gosub LCData
aa = &B00000001
gosub LCData
gosub LCData
gosub LCData
gosub LCData
gosub LCData
aa = &B00000000
gosub LCData

for aa = 1 to 10
  LEDr = 0        ' an
  pause 5
  LEDr = 1        ' aus
  LEDg = 0        ' an
  pause 5
  LEDg = 1        ' aus
  LEDb = 0        ' an
  pause 5
  LEDb = 1        ' aus
next aa
print "$PMTK314,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0*28"   ' nur GPRMC und GPGGA anfordern

if test > 0 then print
if test > 0 then print "Start"
#MainLoop
aa = SECOND
if ManU = on then goto WaitSecond        ' manuelle Uhrzeit
if ManZ = on then goto WaitSecond        ' manuelle Zeitzone
if Sat > 3 then goto WaitSecond
if Sat < 4 then gosub getSat             ' Satelliten suchen
if Sat > 3 then goto InitDate            ' soeben wurden genug Satelliten gefunden
if (SatF = off) AND (MINUTE > 10) then goto Restart    ' keine Satelliten in 10 Minuten
aa = SECOND
#WaitSecond
if KeyP = off then goto Manuell
if SECOND = aa then goto WaitSecond
if (MINUTE = 59) and (SECOND = 10) then goto SetDate
if MINUTE = 59 then goto Min59           ' Hochrechnung ist zu kompliziert
if SECOND < 17 then goto Zero
if SECOND < 19 then goto SommerNormal
if SECOND = 19 then goto Zero
if SECOND = 20 then goto High
if SECOND < 29 then goto DCMinute
if SECOND < 36 then goto DCStunde
if SECOND < 42 then goto DCTag
if SECOND < 45 then goto DCWochentag
if SECOND < 50 then goto DCMonat
if SECOND < 59 then goto DCJahr
sys &h0ce0                               ' Puffer leeren
aa = 71                                  ' "G"
sys &h0101                               ' $GPGGA = Satelliten suchen, sonst nix
goto Display                             ' 59. Sekunde ohne Impuls



#Timeout
ab = 160        ' GPS ist stumm!
gosub Message
#Timeout1
LEDr = 0        ' an
pause 10
LEDr = 1        ' aus
pause 10
goto Timeout1


#Restart
ab = 191        ' 0 Sat, Neustart
gosub Message
Pow  = 1        ' aus
for aa = 1 to 20
  LEDb = 0      ' an
  pause 10
  LEDb = 1      ' aus
  pause 10
next aa         ' 8 Sekunden
goto Init



#getSat
sys &h0ce0                               ' Puffer leeren
aa = 71                                  ' "G"
sys &h0101                               ' $GPGGA = Satelliten suchen
if test > 0 then print Pho;":";Pmi;":";Pse;"   ";Sat;" Satelliten"
if aa = 99 then goto Timeout
if Sat < 1 then return                   ' ohne Satelliten: Zeit ab Einschalten
SatF = on                                ' Satelliten gefunden
HOUR = Pho                               ' UTC stellen
MINUTE = Pmi
SECOND = Pse
return




#InitDate
ab = 175                                 '    Sat, hole ZZ
gosub Message
gosub DispHome
gosub DispSat
#SetDate
if ManU = on then goto MainLoop          ' manuelle Uhrzeit
if test > 0 then print Sat;" Satelliten"
gosub getSat
if Sat < 4 then goto MainLoop            ' Satelliten verloren
sys &h0ce0                               ' Puffer leeren
aa = 82                                  ' "R"
sys &h0101                               ' $GPRMC = Koordinaten und Datum holen
if aa = 99 then goto Timeout
if zi > 48 then Ogps = Ogps + 10000      ' "1"
if NSf = 83 then Ngps = 0 - Ngps         ' "S"
if WEf = 87 then Ogps = 0 - Ogps         ' "W"
if test > 0 then print "Nord=";Ngps;"   Ost";Ogps
if ManZ = off then gosub getZeitZonenZiffer
gosub CalcDOW
gosub SetSummerTime
gosub TimeShift
gosub CalcDOW
goto MainLoop



#Zero
DCO = 0
goto DCOut


#High
DCO = 1
goto DCOut


#SommerNormal
if SECOND = 17 then DCO = SoWi
if SECOND = 18 then DCO = NOT SoWi
goto DCOut



#DCMinute
if (test > 0) AND (SECOND = 21) then print "Minute ";MINUTE
if (test > 0) AND (SECOND = 21) then print "ZZ=";ZZ;"  ZM=";ZM
if SECOND = 21 then Par = 0
if SECOND = 21 then zi = (MINUTE + 1) mod 10                      ' 1 Minute voraus senden!
if SECOND = 25 then zi = (MINUTE + 1) / 10
DCO = zi mod 2
if DCO = ON then Par = NOT Par
zi = zi / 2
if SECOND = 28 then DCO = Par
goto DCOut

#DCStunde
if (test > 0) AND (SECOND = 29) then print "Stunde ";HOUR
if SECOND = 29 then Par = 0
if SECOND = 29 then zi = HOUR mod 10
if SECOND = 33 then zi = HOUR / 10
DCO = zi mod 2
if DCO = ON then Par = NOT Par
zi = zi / 2
if SECOND = 35 then DCO = Par
goto DCOut

#DCTag
if (test > 0) AND (SECOND = 36) then print "Datum ";DAY;".";MONTH;".";YEAR;" dow=";DOW
if SECOND = 36 then Par = 0
if SECOND = 36 then zi = DAY mod 10
if SECOND = 40 then zi = DAY / 10
DCO = zi mod 2
if DCO = ON then Par = NOT Par
zi = zi / 2
goto DCOut

#DCWochentag
if SECOND = 42 then zi = DOW                ' Montag = 1
DCO = zi mod 2
if DCO = ON then Par = NOT Par
zi = zi / 2
goto DCOut

#DCMonat
if SECOND = 45 then zi = MONTH mod 10
if SECOND = 49 then zi = MONTH / 10
DCO = zi mod 2
if DCO = ON then Par = NOT Par
zi = zi / 2
goto DCOut

#DCJahr
if SECOND = 50 then zi = YEAR mod 10
if SECOND = 54 then zi = YEAR / 10
DCO = zi mod 2
if DCO = ON then Par = NOT Par
zi = zi / 2
if SECOND = 58 then DCO = Par
goto DCOut


#Min59
if SECOND > 57 then goto Min5958
if (ManU = on) OR (ManZ = on) then LEDr = 0     ' rot   = manuell
if ManU = off AND SoWi = off then LEDb = 0      ' blau  = Normalzeit
if ManU = off AND SoWi = on  then LEDg = 0      ' grn  = Sommerzeit
goto Display

#Min5958
LEDr = 1      ' rot   = aus
LEDb = 1      ' blau  = aus
LEDg = 1      ' grn  = aus
goto Display



#DCOut
if (ManU = on) OR (ManZ = on) then LEDr = 0     ' rot   = manuell
if ManU = off AND SoWi = off then LEDb = 0      ' blau  = Normalzeit
if ManU = off AND SoWi = on  then LEDg = 0      ' grn  = Sommerzeit
if ZZ > 50 then goto DCOut1
LEDr = 0                                        ' rot   = noch keine ZZ
LEDg = 1
LEDb = 1
#DCOut1
if testb > 0 then print SECOND;". Sek. = ";DCO
DO = on
if DCO = ON then pause 10 else pause 5          ' DCF77-Impuls
DO = off
LEDr = 1
LEDg = 1
LEDb = 1
if ZZ > 50 then goto Display
' ZZ noch nicht definiert: blau --> keine Satelliten, grn --> noch keine Koordinaten
if Sat < 1 then LEDb = 0 else LEDg = 0

#Display                  ' Uhrzeit und Zeitzone anzeigen 11:22:33 +0200 A
aa = &B00000010           ' Init: Home
gosub LCBefehl
ab = HOUR
gosub DispDezi
aa = 58                   ' ":"
gosub LCData
ab = MINUTE
gosub DispDezi
aa = 58                   ' ":"
gosub LCData
ab = SECOND
gosub DispDezi
aa = 32                   ' " "
gosub LCData
if ManU = on then goto manZeit
if Sat < 4 then goto DisplaySat
if (SECOND mod 4) < 2 then goto DisplaySat
aa = 43                   ' "+"
if ZZ < 100 then aa = 45  ' "-"
gosub LCData
ab = abs(ZZ - 100)
gosub DispDezi
ab = ZM
gosub DispDezi
aa = 32                   ' " "
gosub LCData
aa = 65                   ' "A"
if ManZ = on then aa = 77 ' "M"  manuelle Zeitzone
gosub LCData
goto MainLoop


#manZeit
aa = 40                   ' "("
gosub LCData
aa = 109                  ' "m"
gosub LCData
aa = 97                   ' "a"
gosub LCData
aa = 110                  ' "n"
gosub LCData
aa = 46                   ' "."
gosub LCData
aa = 41                   ' ")"
gosub LCData
aa = 32                   ' " "
gosub LCData
goto MainLoop



#DisplaySat
gosub DispSat
aa = 83                   ' "S"
gosub LCData
aa = 97                   ' "a"
gosub LCData
aa = 116                  ' "t"
gosub LCData
aa = 32                   ' " "
gosub LCData
gosub LCData
goto MainLoop




#DispDezi
aa = ab / 10 + 48
gosub LCData
aa = (ab mod 10) + 48
gosub LCData
return


#DispSat
aa = 32
if Sat > 9 then aa = 0    ' Zeichen "1"
gosub LCData
aa = (Sat mod 10) + 48
gosub LCData
return



#DispClear
aa = &B00001100           ' Init: LCD ein, Scrollen aus, Cursor aus
gosub LCBefehl
aa = &B00000001           ' Init: LCD clear
gosub LCBefehl
return

#DispHome
aa = &B00001100           ' Init: LCD ein, Scrollen aus, Cursor aus
gosub LCBefehl
aa = &B00000010           ' Init: LCD home
gosub LCBefehl
return



#Information              ' Datum etc.                    31.12.09 MO RUSS
gosub DispClear           '                               1234567890123456
ab = DAY
gosub DispDezi
aa = 46                   ' "."
gosub LCData
ab = MONTH
gosub DispDezi
aa = 46                   ' "."
gosub LCData
ab = YEAR
gosub DispDezi
aa = 32                   ' " "
gosub LCData
ab = DOW * 2 - 2
looktab WoT, ab, aa
gosub LCData
ab = DOW * 2 - 1
looktab WoT, ab, aa
gosub LCData
aa = 32                   ' " "
gosub LCData
zi = (loc * 7) + 3
looktab Zzo, zi, aa
gosub LCData
zi = zi + 1
looktab Zzo, zi, aa
gosub LCData
zi = zi + 1
looktab Zzo, zi, aa
gosub LCData
zi = zi + 1
looktab Zzo, zi, aa
gosub LCData
#Info1
if KeyP = off then goto Info1   ' warten bis Taste losgelassen
pause 5
#Info2
if KeyP = on  then goto Info2   ' warten bis Taste gedrckt
pause 5
gosub DispClear
ab = abs(Ngps / 100)
gosub DispDezi
aa = 46                   ' "."
gosub LCData
ab = abs(Ngps mod 100)
gosub DispDezi
aa = 78                   ' "N"
if Ngps < 0 then aa = 83  ' "S"
gosub LCData
aa = 32                   ' " "
gosub LCData
Otab = abs(Ogps)
aa = 32                   ' " "
if Otab < 10000 then goto Info3
Otab = Otab - 10000
aa = 49                   ' "1"
#Info3
gosub LCData
ab = Otab / 100
gosub DispDezi
aa = 46                   ' "."
gosub LCData
ab = abs(Ngps mod 100)
gosub DispDezi
aa = 79                   ' "O"
if Ogps < 0 then aa = 87  ' "W"
gosub LCData
gosub DispSat

#Info4
if KeyP = off then goto Info4   ' warten bis Taste losgelassen
pause 5
#Info5
if KeyP = on  then goto Info5   ' warten bis Taste gedrckt
gosub DispClear
pause 5
#Info9
if KeyP = off then goto Info9   ' warten bis Taste losgelassen
goto MainLoop



#LCBefehl
LCDP = aa
LCDD = 0
LCDE = 0
LCDE = 1
return

#LCData
LCDP = aa
LCDD = 1
LCDE = 0
LCDE = 1
return


#Message
gosub DispClear
#Message1
looktab Msg, ab, aa     ' 1. Zeichen in steht in ab
if aa < 1 then return
gosub LCData
ab = ab + 1
goto Message1




#Manuell
ab = 132                ' "Information"
gosub Message
pause 100
if KeyP = on then goto Information
ab = 0                  ' "Zeitzone"
gosub Message
pause 100
if KeyP = on then goto SetZeitZone
ab = 16                 ' "Uhr stellen"
gosub Message
pause 100
if KeyP = on then goto SetTime
ab = 62                 ' "automatisch"
gosub Message
pause 100
if KeyP = on then goto Automatisch
ab = 207                ' "Helligkeit"
gosub Message
pause 100
if KeyP = on then goto Helligkeit
goto Manuell


#SetZeitZone
ManZ = on
ab = 28                 ' "Zeitzone Std"
gosub Message
gosub DispHome
aa = &B00001110         ' LCD an, Cursor an, blinkt
gosub LCBefehl
ZZ = 100
#SetZeitZone1
if KeyP = on then goto SetZeitZone1  ' warten bis Taste gedrckt
gosub DispHome
aa = 32
if ZZ < 100 then aa = 45 ' "-"
if ZZ > 100 then aa = 43 ' "+"
gosub LCData
ab = abs(ZZ - 100)
aa = ab / 10 + 48
gosub LCData
aa = (ab mod 10) + 48
gosub LCData
aa = &B00010000                      ' Cursor nach links
gosub LCBefehl
pause 50
if KeyP = on then goto SetZeitZoneMin
ZZ = ZZ + 1
if ZZ > 112 then ZZ = 88
goto SetZeitZone1

#SetZeitZoneMin
ab = 45                 ' "Zeitzone Min"
gosub Message
gosub DispHome
aa = &B00001110         ' LCD an, Cursor an, blinkt
gosub LCBefehl
ZM = 0
#SetZeitZone3
if KeyP = on then goto SetZeitZone3  ' warten bis Taste gedrckt
gosub DispHome
aa = 32
gosub LCData
aa = ZM / 10 + 48
gosub LCData
aa = (ZM mod 10) + 48
gosub LCData
aa = &B00010000                      ' Cursor nach links
gosub LCBefehl
pause 50
if KeyP = on then goto SetEnd
ZM = ZM + 15
if ZM > 55 then ZM = 0
goto SetZeitZone3


#SetTime
ManU = on
ab = 90                 ' "Jahr"
gosub Message
zi = YEAR               ' wird gendert
ab = 99                 ' Minimum * 100 + Maximum
gosub SetDezi
YEAR = zi
ab = 81                 ' "Monat"
gosub Message
zi = MONTH              ' wird gendert
ab = 112                ' Minimum * 100 + Maximum
gosub SetDezi
MONTH = zi
ab = 74                 ' "Tag"
gosub Message
zi = DAY                ' wird gendert
gosub MaxDays
ab = ab + 100           ' Minimum * 100 + Maximum
gosub SetDezi
DAY = zi
gosub CalcDOW
ab = 98                 ' "Stunde"
gosub Message
zi = HOUR               ' wird gendert
ab = 23                 ' Minimum * 100 + Maximum
gosub SetDezi
HOUR = zi
ab = 108                ' "Minute"
gosub Message
zi = MINUTE             ' wird gendert
ab = 59                 ' Minimum * 100 + Maximum
gosub SetDezi
MINUTE = zi
aa = &B00001100         ' LCD ein, Scrollen aus, Cursor aus
gosub LCBefehl
ab = 118                ' "Taste = Start"
gosub Message
#SetTime1
SECOND = 0
if KeyP = on then goto SetTime1  ' warten bis Taste gedrckt
goto SetEnd


#Automatisch
ManZ = off
ManU = off
#SetEnd
if KeyP = off then goto SetEnd   ' warten bis Taste losgelassen
aa = &B00001100         ' LCD ein, Scrollen aus, Cursor aus
gosub LCBefehl
goto SetDate


#SetDezi
gosub DispHome
aa = &B00001110                          ' LCD an, Cursor an, blinkt
gosub LCBefehl
aa = zi / 10 + 48                        ' vernderlicher Wert in zi
gosub LCData
aa = (zi mod 10) + 48
gosub LCData
aa = &B00010000                          ' Cursor nach links
gosub LCBefehl
#SetDezi1
if KeyP = on then goto SetDezi1          ' warten bis Taste gedrckt
SECOND = 0                               ' berlauf verhindern
gosub DispHome
aa = zi / 10 + 48                        ' vernderlicher Wert in zi
gosub LCData
aa = (zi mod 10) + 48
gosub LCData
aa = &B00010000                          ' Cursor nach links
gosub LCBefehl
pause 50
if KeyP = on then return                 ' Taste losgelassen
zi = zi + 1
if zi > (ab mod 100) then zi = ab / 100  ' > Maximum --> Minimum
goto SetDezi1



#Helligkeit
if KeyP = on then goto Helligkeit        ' warten bis Taste gedrckt
NSf = 8
WEf = 255
#HellLoop
ab = 207                                 ' "Helligkeit "
gosub Message
aa = NSf + 48                            ' 1...8
gosub LCData
Hell = WEf
LEDr = 0        ' an
pause 25
LEDr = 1        ' aus
LEDg = 0        ' an
pause 25
LEDg = 1        ' aus
LEDb = 0        ' an
pause 25
LEDb = 1        ' aus
if KeyP = on then goto MainLoop          ' Taste losgelassen
NSf = NSf - 1
WEf = WEf / 2
if NSf > 0 then goto HellLoop
NSf = 8
WEf = 255
goto HellLoop



#MaxDays
looktab Dmo, MONTH, ab                   ' max. Tage im Monat in ab
if MONTH <> 2 then return
if (YEAR mod 4) = 0 then ab = ab + 1
return



#CalcDOW
zi = 6 + (YEAR + YEAR / 4) MOD 7         ' Jahrhundert-Zahl + Jahreszahl
looktab DoM, MONTH, aa                   ' Monatszahl
zi = zi + aa + DAY                       ' Tageszahl
aa = 0
if (YEAR mod 4) = 0 then aa = 6          ' Schaltjahr
if MONTH > 2 then aa = 0                 ' nur Jan und Feb
zi = (zi + aa) mod 7
if zi < 1 then zi = 7
DOW = zi
return




#getZeitZonenZiffer
aa = 0
#ZZZ1
looktab Coo, aa, zi
if zi = 99 then return                ' Ende der Tabelle
aa = aa + 1
#ZZZ2
looktab Coo, aa, Otab                 ' min. Werte
aa = aa + 1
looktab Coo, aa, Ntab
aa = aa + 1
if Ntab > 9900 then goto ZZZ1         ' Ende der Zeitzone
if Ogps < Otab then goto ZZZ2
if Ngps < Ntab then goto ZZZ2
looktab Coo, aa, Otab                 ' max. Werte
aa = aa + 1
looktab Coo, aa, Ntab
aa = aa + 1
if Ogps > Otab then goto ZZZ2
if Ngps > Ntab then goto ZZZ2
loc = zi                              ' alles passt
if test > 0 then print "Zeitzone ";loc; " passt: ";
zi = zi * 7
looktab Zzo, zi, ab
ZZ = ab
zi = zi + 1
looktab Zzo, zi, ab
ZM = ab
if test > 0 then print ZZ;":";ZM
goto ZZZ2



#TimeShift
if SECOND > 55 then goto TimeShift
if ZZ < 100 then goto TimeBack
MINUTE = MINUTE + ZM
if MINUTE < 60 then goto TimeShift1
MINUTE = MINUTE - 60
HOUR = HOUR + 1
#TimeShift1
HOUR = HOUR + (ZZ - 100)
if SoWi = on then HOUR = HOUR + 1
if HOUR < 24 then return
#TimeShift2
HOUR = HOUR - 24
DAY = DAY + 1
gosub MaxDays
if DAY <= ab then return
DAY = 1
MONTH = MONTH + 1
if MONTH < 13 then return
MONTH = 1
YEAR = YEAR + 1
return
#TimeBack
MINUTE = MINUTE - ZM
if MINUTE > 0 then goto TimeBack1
MINUTE = MINUTE + 60
HOUR = HOUR - 1
#TimeBack1
HOUR = HOUR + (ZZ - 100)
if SoWi = on then HOUR = HOUR + 1
if HOUR > 23 then goto TimeShift2
if HOUR >= 0 then return
HOUR = HOUR + 24
DAY = DAY - 1
if DAY > 0 then return
MONTH = MONTH - 1
if MONTH > 0 then goto TimeBack2
MONTH = 12
YEAR = YEAR - 1
#TimeBack2
gosub MaxDays
DAY = ab
return



#SetSummerTime                                     ' wird in der 59. Minute (UTC) aufgerufen!
SoWi = off                                         ' deshalb Umstellung 1 Stunde frher!
if test > 0 then print "loc = "; loc
if loc = 1 then goto SS_Europa
if loc = 3 then goto SS_Europa
if loc = 4 then goto SS_Europa
return

#SS_Europa
if MONTH <  3 then return
if MONTH > 10 then return
if MONTH =  3 then goto SS_Europa1
if MONTH = 10 then goto SS_Europa2
#SS_Europa0
SoWi = on
return
#SS_Europa1
if test > 0 then print "DAY = "; DAY
if DAY < 25 then return
aa = DAY - DOW                                     ' vor dem 25. Mrz
if test > 0 then print "aa = "; aa; "   DOW = "; DOW
if (DOW < 7) AND (aa < 25) then return             ' vor dem letzten Sonntag
if aa > 24 then goto SS_Europa0                    ' nach dem letzten Sonntag
if test > 0 then print "aa = "; aa
if HOUR < 1 then return                            ' vor 01:59 Uhr UTC  --> Normalzeit
goto SS_Europa0                                    ' nach 01:59 Uhr UTC --> Sommerzeit
#SS_Europa2
if DAY < 25 then goto SS_Europa0
aa = DAY - DOW                                     ' vor dem 25. November
if (DOW < 7) AND (aa < 25) then goto SS_Europa0    ' vor dem letzten Sonntag
if aa > 24 then return                             ' nach dem letzten Sonntag
if HOUR < 2 then goto SS_Europa0                   ' vor 02:59 Uhr UTC --> Sommerzeit
return                                             ' nach 02:59 Uhr UTC --> schon Normalzeit


end


TABLE WoT  77 79  68 73  77 73  68 79  70 82  83 65  83 79                     '  MO DI MI DO FR SA SO
           TABEND

TABLE Dmo  00 31 28 31 30 31 30 31 31 30 31 30 31                              '  max. Tage pro Monat
           TABEND

TABLE DoM  0 0 3 3 6 1 4 6 2 5 0 3 5                                           '  Tageszahlen
           TABEND
                                                                               '       1234567890123456
TABLE Msg  90 101 105 116 122 111 110 101  32 115 101 116 122 101 110   0      '    0  Zeitzone setzen
           85 104 114  32 115 116 101 108 108 101 110   0                      '   16  Uhr stellen
           32  48  48  32  90 101 105 116 122 111 110 101  32  83 116 100   0  '   28   00 Zeitzone Std
           32  48  48  32  90 101 105 116 122 111 110 101  32  77 105 110   0  '   45   00 Zeitzone Min
           97 117 116 111 109  97 116 105 115  99 104   0                      '   62  automatisch
           32  32  32  84  97 103   0                                          '   74     Tag
           32  32  32  77 111 110  97 116   0                                  '   81     Monat
           32  32  32  74  97 104 114   0                                      '   90     Jahr
           32  32  32  83 116 117 110 100 101   0                              '   98     Stunde
           32  32  32  77 105 110 117 116 101   0                              '  108     Minute
           84  97 115 116 101  32  61  32  83 116  97 114 116   0              '  118  Taste = Start
           73 110 102 111 114 109  97 116 105 111 110   0                      '  132  Information
           73 110 105 116 105  97 108 105 115 105 101 114 117 110 103   0      '  144  Initialisierung
           71  80  83  32 105 115 116  32 115 116 117 109 109  33   0          '  160  GPS ist stumm!
           32  32  32  83  97 116  44  32 104 111 108 101  32  90  90   0      '  175     Sat, hole ZZ
           48  32  83  97 116  44  32  78 101 117 115 116  97 114 116   0      '  191  0 Sat, Neustart
           72 101 108 108 105 103 107 101 105 116  32   0                      '  207  Helligkeit
           TABEND

'Zeitzonen +h   +m   Uhrzeit
TABLE Zzo  101  00   00        85 78 66 75    ' 00 UNBK
           101  00   03        77 69 90 32    ' 01 MEZ
           103  00   04        82 85 83 83    ' 02 RUSS
           100  00   02        71 77 84 32    ' 03 GMT
           102  00   04        79 69 90 32    ' 04 OEZ
           107  00   99        84 72 65 73    ' 05 THAI
           TABEND

TABLE Coo  0             ' UNBK
         -18000 -9000 18000  9000     ' min Ost, min Nord, max Ost, max Nord   [GGmm]
           9999  9999
           1             ' MEZ
           -927  3749  2659  7529
           -914  3558  -146  3836
           -214  3702     5  3824
           1204  3527  1654  3846
           2637  6902  3116  7123
           9999  9999

           2             ' RUSS
           2720  4139  5048  7528
           9999  9999

           3             ' GMT
          -1135  3558  -725  4200
          -2736  5021   125  6737
           -629  4943  -242  5052
            108  5101   137  5134
            110  5142   207  5304
           -741  3755  -706  3911
           -743  3940  -650  4201
           -659  4114  -625  4159
           9999  9999

           4             ' OEZ
           2340  6336  3007  6845
           2553  6835  2859  6955
           2029  6135  3010  6340
           1910  5411  2813  6147
           2333  5014  3144  5606
           2241  4046  3828  5055
           2059  3257  4102  4108
           2157  6817  2352  6843
           2058  6838  2202  6917
           2203  6330  2402  6436
           2955  6220  3116  6325
           2956  6159  3036  6222
           2803  6113  2926  6138
           2805  6053  2849  6115
           3125  5309  3235  5348
           3126  5047  3412  5217
           3359  5044  3514  5114
           3759  4743  3946  4956
           4028  3701  4359  4134
           2008  3646  2114  4003
           2148  4429  2303  4744
           2124  4441  2201  4655
           2037  4523  2132  4622
           9999  9999

           5             ' THAI
           9734  1701 10120  2021
           9822  1405 10510  1804
           9911   541 10233  1423
           9756   700  9929  1047
           9999  9999

           99
           TABEND



' syscode "Assembl\GPS.s19"

