Nhi  equ  $a1            ; Nord
Nlo  equ  $a2
Ehi  equ  $a3            ; Ost
Elo  equ  $a4
Sat  equ  $a9            ; byte[09]
NSf  equ  $aa            ; byte[10]
WEf  equ  $ab            ; byte[11]
aa   equ  $ac            ; byte[12]   Kennbuchstabe 47=G oder 52=R
ab   equ  $ad            ; byte[13]
zi   equ  $ae            ; byte[14]

CNT  equ  $63            ; FIFO-Zhler
TIH  equ  $8e            ; Timer
TIL  equ  $8f

Pho  equ  $b2            ; vorlufige Stunde
Pmi  equ  $b3            ; vorlufige Minute
Pse  equ  $b4            ; vorlufige Sekunde
DAY  equ  $6a            ; DAY
MON  equ  $82            ; MONTH
YER  equ  $90            ; YEAR

Ser  equ  $0cb5          ; Byte aus serieller Schnittstelle in Akku
Mul  equ  $1b84          ; 2 Words multiplizieren


     org  $101

     bset #4,$04         ; DCF77-OK-LED-Pin auf Ausgang schalten
     bclr #4,$00         ; DCF77-OK-LED einschalten
     clr TIH
     lda #250            ; Timer 250 * 20ms = 5 Sekunden
     sta TIL             ; speichern
Start:
     tst TIL             ; Zhler auf Null?
     beq timeout         ; schon 5 Sekunden vergangen...
     tst CNT             ; liegt neues Byte bereit?
     beq Start           ; nein
     jsr Ser             ; Byte aus serieller Schnittstelle in Akku
     cmp #$24            ; "$"
     bne Start
     jsr Ser             ; Byte aus serieller Schnittstelle in Akku "G"
     jsr Ser             ; Byte aus serieller Schnittstelle in Akku "P"
     jsr Ser             ; Byte aus serieller Schnittstelle in Akku
     cmp aa              ; 3. Kennbuchstabe wie erwartet?
     bne Start           ; nein
     cmp #$47            ; "G"
     bne GPRMC           ; nicht "G"




                         ; $GPGGA,203601.000,6107.3477,N,02131.9876,E,1,10,1.02,21.8,M,21.1,M,,*57
                         ; $GPGGA,170623.000,6107.3525,N,02131.9586,E,1,6,1.14,69.3,M,21.1,M,,*63
                         ;        Uhrzeit    Nord        Ost            Anz.Sat.
GPGGA:
     jsr waitkomma       ; "GA,"
     jsr decin           ; 2 Ziffern holen
     sta Pho             ; vorlufige Stunde
     jsr decin           ; 2 Ziffern holen
     sta Pmi             ; vorlufige Minute
     jsr decin           ; 2 Ziffern holen
     sta Pse             ; vorlufige Sekunde
     lda #6
     sta Sat             ; auf 6 Kommata warten
wait6k:
     jsr waitkomma
     dec Sat
     bne wait6k
     jsr Ser             ; Byte aus serieller Schnittstelle in Akku : Anzahl Satelliten
     sub #$30            ; "0"
     sta Sat             ; Anzahl Sat
     jsr Ser             ; Byte aus serieller Schnittstelle in Akku : Anzahl Satelliten
     sta aa              ; nchstes Zeichen merken
     sub #$30            ; "0"
     bcs exit            ; war Komma --> fertig
     add #10             ; war Ziffer --> plus Zehnerstelle
     sta Sat
     bra exit            ; TODO FOR BASIC: wenn mehr als 3 Satelliten --> Uhr stellen


timeout:
     lda #99
     sta aa              ; aa = 99 --> Timeout
exit:
     clr TIL             ; Timer lschen, sonst PAUSE
     bset #4,$00         ; DCF77-OK-LED ausschalten
     rts


                         ; $GPRMC,170623.000,A,6107.3525,N,02131.9586,E,1.80,246.86,020209,,,A*63
                         ;        Uhrzeit      Nord      S Ost        W             Datum
GPRMC:
     jsr waitkomma       ; "MC,"
     jsr waitkomma       ; "Uhrzeit,"
     jsr waitkomma       ; "A,"
     jsr gradin          ; Nordgrad lesen
     lda Elo             ; kopiere Ost nach Nord
     sta Nlo
     lda Ehi
     sta Nhi
     jsr waitkomma
     jsr Ser             ; Byte aus serieller Schnittstelle in Akku
     sta NSf             ; N/S-Buchstabe speichern
     jsr Ser             ; Byte aus serieller Schnittstelle in Akku ","
     jsr Ser             ; Byte aus serieller Schnittstelle in Akku = Ost-100-er
     sta zi              ; zwischenspeichern
     jsr gradin          ; Ostgrade lesen
     jsr waitkomma
     jsr Ser             ; Byte aus serieller Schnittstelle in Akku
     sta WEf             ; W/E-Buchstabe speichern
     jsr waitkomma
     jsr waitkomma
     jsr waitkomma
     jsr decin           ; 2 Ziffern holen
     sta DAY             ; DAY
     jsr decin           ; 2 Ziffern holen
     sta MON             ; MONTH
     jsr decin           ; 2 Ziffern holen
     sta YER             ; YEAR
     bra exit            ; TODO FOR BASIC: Ost+10000 falls zi>48; Grade umkehren falls Sd oder West




decin:                   ; 2-stellige Dezimalzahl einlesen
     jsr Ser             ; Byte aus serieller Schnittstelle in Akku
     sub #$30            ; ASCII -> Num
     sta $55
     clr $54             ; High-Byte = 0
     lda #10             ; * 10
     sta $57
     clr $56             ; High-Byte = 0
     jsr $1b84           ; Word multipl.
     jsr Ser             ; Byte aus serieller Schnittstelle in Akku
     sub #$30            ; ASCII -> Num
     add $55             ; + Zehnerstelle
     rts



gradin:
     jsr decin           ; Gradzahl lesen
     sta $55             ; = Low-Byte
     clr $54             ; High-Byte = 0
     lda #100            ; * 100
     sta $57
     clr $56             ; High-Byte = 0
     jsr Mul             ; Word multipl.
     lda $54             ; High-Byte
     sta Ehi             ; --> Ost-Grad
     lda $55             ; Low-Byte
     sta Elo             ; --> Ost-Minuten
     jsr decin           ; Minutenzahl lesen
     add $a4             ;
     sta $a4             ; + Ost-Minuten
     lda $a3
     adc #$00            ; evtl. Ost-Grad korrigieren
     sta $a3
     rts



waitkomma:
     jsr Ser             ; Byte aus serieller Schnittstelle in Akku
     cmp #44             ; ","
     bne waitkomma
     rts



